<?php

if(isset($_GET['minSupport']) && isset($_GET['minConfidence'])){
	$tempoTotal = microtime(TRUE);
	$minSupport = $_GET['minSupport'];
	$minConfidence = $_GET['minConfidence'];
	$entrada = entrada();
	$entrada = explode("\n", $entrada);
	$transacoes = corrigeEntrada($entrada);
	$numTransacoes = count($transacoes);
	$minFrequency = $minSupport * count($transacoes);

	echo '<pre>';	
	echo '<h1>Transacoes ('.$numTransacoes.' - '.$minFrequency.' - '.$minSupport.' - '.$minConfidence.' )</h1>';
	echo '<h1>APRIORI</h1>';		
	$base = resolveApriori($transacoes);
	$rules = ruleGen($base, $minConfidence);
	echo '<h1>RESULTADO APRIORI</h1>';		
	print_r($base);
	echo '<h1>REGRAS</h1>';	
	print_r($rules);
	echo 'Tempo de execucao: '.round((microtime(TRUE) - $tempoTotal), 1).' microssegundos';

	echo '</pre>';
}
else{
	formEntrada();
}

function entrada(){


	return file_get_contents('./teste.txt', 'r');
}

//recebe um array com pares (id_produto,id_transacao) e devolve um array com strings no formato (id_produto_1,id_produto_2,...,id_produto_n-1,id_produto_n) para cada transacao
function geraEntrada($linhas){
	$entrada = array();
	$aux_ant = explode(',', $linhas[0]);
	$aux_ant = array_map('intval', $aux_ant);			
	$linha_aux[0] = $aux_ant[0];

	for($i = 1; $i < count($linhas); $i++){
		$aux_atual = explode(',', $linhas[$i]);
		$aux_atual = array_map('intval', $aux_atual);
		if($aux_atual[1] == $aux_ant[1]){
			$linha_aux[] = $aux_atual[0];
		}
	else{
		$entrada[] = implode(",", $linha_aux);
		$linha_aux = array();
		$linha_aux[0] = $aux_atual[0];
	}
	$aux_ant[1] = $aux_atual[1];
	}
	$entrada[] = implode(",", $linha_aux);
	
	return $entrada;
}

function formEntrada(){
	$form = '<form action="apriori.php" method="GET" >
				<div> minSupport: <input name="minSupport" type="text" value="" /></div>
				<div> minConfidence: <input name="minConfidence" type="text" value="" /></div>
				<input type="submit" />
			</form>';
	echo $form;
}

//esta funcao resolve o algoritmo apriori recebendo o array de transacoes e retornando a matriz L, onde L[k] armazena os frequent k-itemsets e suas frequencias (a chave é o itemset e o valor sua frequencia)
function resolveApriori($transacoes){
	$L = array();
	
	$L[1] = large1itemsets($transacoes);

	ksort($L[1], SORT_NUMERIC);//ordena pela chave apenas para organizar a saida
			
	for($k = 2; !empty($L[$k - 1]); $k++){

		echo '<h2>Nivel: '.$k.'</h2>';
		$tempoParcial = microtime(TRUE);			
		$Ck = aprioriGen($L[$k - 1]);
		echo 'Tempo aprioriGen '.(microtime(TRUE) - $tempoParcial).' microssegundos <br />';
					
		$tempoParcial = microtime(TRUE);
		foreach($transacoes as $t){
				
			//se o numero de produtos da transacao for menor que k, vai para a proxima
			if(count(explode(',', $t)) < $k){
				continue;
			}				
			$Ct = subset($Ck, $t, $k);
			foreach($Ct as $candidato){
				if(!isset($L[$k][$candidato]))
					$L[$k][$candidato] = 1;
				else
					$L[$k][$candidato]++;
			}			
		}
		echo 'Tempo geracao subsets '.(microtime(TRUE) - $tempoParcial).' microsegundos <br />';
		
		$tempoParcial = microtime(TRUE);
		if(!empty($L[$k])){
			$L[$k] = filtraCandidatos($L[$k]);
			ksort($L[$k], SORT_NUMERIC);//ordena pela chave apenas para organizar a saida
		}
		echo 'Tempo do filtro'.(microtime(TRUE) - $tempoParcial).' microsegundos <br />';
		
	}
	return $L;
}

//calcula a regra para todos os casos possiveis e armazena as regras cuja confianca satisfazem a confianca minima. recebe a matriz $L, que contem todos os conjuntos de itens frequentes, e devolve um vetor com todas as regras e suas respectivas confiancas no formato [regra] => confianca
function ruleGen($L){
	global $minConfidence;
	$regras = array();
	for($i = 2; $i <= count($L); $i++){
		foreach($L[$i] as $freqItemset => $frequencia){
			for($j = 1; $j < $i; $j++){
				$combinacoes = combinacao($freqItemset, $i - $j);
					foreach($combinacoes as $subset){
						if(($L[$i][$freqItemset] / $L[$i - $j][$subset]) > $minConfidence){
							$regra = escreveRegra($freqItemset, $subset);
							$regras[$regra] = $L[$i][$freqItemset] / $L[$i - $j][$subset];
						}
					}
			}
		}
	}
	return $regras;
}

//funcao auxiliar que gera o texto da regra, caso ela satisfaca a confianca minima. recebe o conjunto de itens frequentes e um subconjunto dele, e devolve a string que contempla a regra (ex: [12,34=>56])
function escreveRegra($freqItemset, $subset){
	$a = explode(',', $subset);
	$b = explode(',', $freqItemset);
	$c = 0;
	$d = 0;
	while(!empty($a)){		
		if($b[$c] == $a[$d]){
			unset($a[$d]);
			unset($b[$c]);
			$c++; $d++;
		}
		else{
			$c++;
		}
	}
	return $subset.'=>'.implode(',', $b);
}

//gera o nivel 1
function large1Itemsets($transacoes){
	global $minFrequency;
	$itemsets = array();
	foreach($transacoes as $t){
		$produtos = explode(',', $t);
		foreach($produtos as $p){
			if(isset($itemsets[$p])){
				$itemsets[$p]++;
			}
			else{
				$itemsets[$p] = 1;
			}
		}
	}
	foreach($itemsets as $key => $value){
		if($value < $minFrequency){
			unset($itemsets[$key]);
		}
	}
	return $itemsets;
}

//gera os k-itemsets, que sao candidatos
function aprioriGen($itemsets){
	$novoItemsets = array();
	$itemsetsKeys = array_keys($itemsets);
	for($i = 0; $i < count($itemsetsKeys); $i++){
		for($j = $i + 1; $j < count($itemsetsKeys); $j++){
			$produtos = explode(',', $itemsetsKeys[$j]);
			$tupla = $itemsetsKeys[$i].','.$produtos[count($produtos) - 1];
			$novoItemsets[$tupla] = $tupla;
		}
	}
	return $novoItemsets;
}

//gera todos os subsets de tamanho k da transacao e verifica se existe candidato igual. em caso positivo adiciona no array que sera retornado
function subset($Ck, $transacao, $k){
	$candidatos = array();	
	$combinacoesTransacao = combinacao($transacao, $k);	
	foreach($combinacoesTransacao as $combinacao){
		if(isset($Ck[$combinacao]))
			$candidatos[$combinacao] = $combinacao;
	}
	return $candidatos;
}

//recebe um array com [candidato] => frequencia e elimina os candidatos que estao abaixo de minsupport
function filtraCandidatos($l){
	global $minFrequency;
	foreach($l as $key => $value){
		if($value < $minFrequency){
			unset($l[$key]);
		}			
	}
	return $l;	
}

//limpa os "\n" da entrada e ordena os itens em cada linha de transacao
function corrigeEntrada($entrada){
	$transacoesProdutos = array();
	foreach($entrada as $tA){
		$produtos = explode(',', $tA);
		$produtos = array_map('intval', $produtos);	
		sort($produtos, SORT_NUMERIC);
		$transacoesProdutos[] = $produtos;
	}
	for($i = 0; $i < count($transacoesProdutos); $i++){
		$produtos = implode(',', $transacoesProdutos[$i]);
		$entrada[$i] = $produtos;
	}
	return $entrada;
}

//funcao de comparacao do usort usada para ordenar as transacoes numericamente
function comparaArraysProdutosParaOrdenacao($produtos1, $produtos2){
	$item1 = array_shift($produtos1);
	$item2 = array_shift($produtos2);
	
	if($item1 == NULL){
		return -1;
	}
	if($item2 == NULL){
		return 1;		
	}
	if($item1 > $item2){
		return 1;
	}
	else if($item1 < $item2){
		return -1;
	}
	else 		
		return comparaArraysProdutosParaOrdenacao($produtos1, $produtos2);
	
}

//usa a funcao "combinacoesPossiveis" para gerar todas as combinacoes de produtos possiveis de tamanho "tamanhoCombinacao", dada uma transacao "transacao" (note que a quantidade de combinacoes geradas sera Comb(count(transacao),tamanhoCombinacao)). ela devolve o vetor "combinacoesFinal" que contem todas as transacoes
function combinacao($transacao, $tamanhoCombinacao){
	$arrayProdutos = explode(',', $transacao);
	$n = count($arrayProdutos);
	$combinacoesPossiveis = array();
	$combinacoesFinal = array();
 
	//devolve todas as combinacoes em $combinacoesFinal
	combinacoesPossiveis($arrayProdutos, $combinacoesPossiveis, 0, $n, 0, $tamanhoCombinacao, $combinacoesFinal);
	
	for($i = 0; $i < count($combinacoesFinal); $i++){
		$combinacoesFinal[$i] = implode(',', $combinacoesFinal[$i]);
	}
			
	return $combinacoesFinal;
}	


//funcao auxiliar da funcao "combinacao" que gera todos as combinacoes possiveis de tamanho tamanhoCombinacao a partir dos itens em arrayProdutos 
function combinacoesPossiveis($arrayProdutos, &$combinacoesPossiveis, $start, $end, $index, $tamanhoCombinacao, &$combinacoesFinal){
	if ($index == $tamanhoCombinacao){ // combinacao esta pronta
		$combinacoesFinal[] = $combinacoesPossiveis;
		return;
	}
	for ($i = $start; $i < $end && $end - $i + 1 >= $tamanhoCombinacao - $index; $i++){
		$combinacoesPossiveis[$index] = $arrayProdutos[$i];
		combinacoesPossiveis($arrayProdutos, $combinacoesPossiveis, $i + 1, $end, $index + 1, $tamanhoCombinacao, $combinacoesFinal);
	}
}

?>