<?php

$tempoTotal = microtime(TRUE);

if(isset($_GET['minSupport']) && isset($_GET['minConfidence'])){
	$minSupport = $_GET['minSupport'];
	$minConfidence = $_GET['minConfidence'];
	$numTransacoes = calculaNumeroTransacoes();
	$minFrequency = $minSupport * $numTransacoes;

	echo '<pre>';	

	echo '<h1>Transacoes ('.$numTransacoes.' - '.$minFrequency.' - '.$minSupport.' - '.$minConfidence.' )</h1>';
	echo '<h1>APRIORI</h1>';		
	$base = resolveAprioriSQL();
	$rules = ruleGen($base);
	echo '<h1>RESULTADO APRIORI</h1>';		
	print_r($base);
	echo '<h1>REGRAS</h1>';	
	print_r($rules);
	echo 'Tempo de execucao: '.round((microtime(TRUE) - $tempoTotal), 1).' microssegundos';
	echo '</pre>';

}
else{
	formEntrada();
}


function formEntrada(){
	$form = '<form action="apriori.php" method="GET" >
				<div> minSupport: <input name="minSupport" type="text" value="" /></div>
				<div> minConfidence: <input name="minConfidence" type="text" value="" /></div>
				<input type="submit" />
			</form>';
	echo $form;
}

//devolve o numero de transacoes do BD
function calculaNumeroTransacoes(){
	$query = 'SELECT COUNT(DISTINCT id_pedido_pedido) as transacoes FROM produto_pedido';
	$resultado = executaQuery($query);
	return $resultado[0]['transacoes'];
}

function resolveAprioriSQL(){
	global $minConfidence;
	$L = array();
	
	$L[1] = large1itemsets();
	ksort($L[1], SORT_NUMERIC);//ordena pela chave apenas para organizar a saida
				
	for($k = 2; !empty($L[$k - 1]); $k++){

		echo '<h2>Nivel: '.$k.'</h2>';
		$tempoParcial = microtime(TRUE);			
		$result = freqItemsetGen($L[$k - 1], $k);
		if(!empty($result)){
			$L[$k] = $result;
		}
		
		echo 'Geracao Level '.$k .' - '. (microtime(TRUE) - $tempoParcial) . ' microsegundos <br />';
	}
	
	return $L;
}


//recebe uma query e devolve um array com os resultados dela
function executaQuery($query){
	$consulta = array();
	
	$bdcon = pg_connect('host=localhost dbname=tfs_bd user=postgres password=postgresql')
	or die('Could not connect: ' . pg_last_error());
	pg_query($query)
	or die('Query failed: ' . pg_last_error());
	
	$result = pg_query($bdcon, $query);

	while($row = pg_fetch_array($result)){
		$consulta[] = $row;
	}
	
	pg_close($bdcon);
	
	return $consulta;	
}


function freqItemsetGen($freqItemsetAnterior, $k){
	//gera a query do nivel k com os produtos pertinentes
	$query = geraQuery($freqItemsetAnterior, $k);
	//roda a query e recebe o resultado
	$resultado = executaQuery($query);
	
	$itemsets = array();
	foreach($resultado as $r){
		$prods = array();
		for($i = 1; $i <= $k; $i++)
			$prods[] = $r['id_produto_produto'. $i];
		$prods = implode(',', $prods);
		$itemsets[$prods] = $r['total'];
	}
	
	return $itemsets;
}

//recebe um array com os frequent itemsets de k - 1 e devolve um array com todos os produtos unicos desse set
function produtosUnicos($itemset){
	$produtosUnicos = array();
	
	foreach($itemset as $key => $value){
		$produtos = explode(',', $key);
		
		foreach($produtos as $p){
			$produtosUnicos[$p] = $p;
		}
	}
	
	return $produtosUnicos;	
}


//recebe os produtos unicos dos frequent itemsets do nivel k - 1, e o nivel k, e devolve o texto da query que gera os frequent itemsets de nivel k. abaixo tem a query gerada para o nivel 3 com as relacoes com cada parte da funcao
function geraQuery($freqItemsetAnterior, $k){
	global $minFrequency;

	//pega todos os produtos unicos dos frequent itemsets do nivel anterior
	$produtosNivelAnterior = produtosUnicos($freqItemsetAnterior);

	//escreve as colunas a serem consultadas
	$colunas = array();
	for($i = 1; $i <= $k; $i++)
		$colunas[] = ' pp'.$i.'.id_produto_produto AS id_produto_produto'.$i.' ';	
	$query = 'SELECT '.implode(', ', $colunas).', COUNT(*) as total ';
	
	//escreve as tabelas cujas colunas serao consultadas
	$tabelas = array();
	for($i = 1; $i <= $k; $i++){
		$tabelas[] = ' produto_pedido pp'.$i.' ';
	}
	$query .= ' FROM '.implode(', ', $tabelas);
	
	//escreve as condicoes da consulta
	$condicoes = array();
	//escreve o inicio das condicoes da query
	$condicoes[] = ' pp1.id_produto_produto IN ('.implode(',', $produtosNivelAnterior).') ';
	for($i = 2; $i <= $k; $i++){
//		$condicoes[] = ' pp1.id_pedido_pedido = pp'.$i.'.id_pedido_pedido '; //condicao de igualdade do id das tabelas
		$condicoes[] = ' pp'.$i.'.id_produto_produto IN ('.implode(',', $produtosNivelAnterior).') '; // condicao para que apenas os produtos do frequent itemset de nivel k - 1 sejam consultados 
		$condicoes[] = ' pp'.$i.'.id_produto_produto > pp'.($i - 1).'.id_produto_produto '; //condicao que evita repeticoes de itemsets com produtos em ordem diferente e garante a ordem numerica entre os produtos
	}	
	$query .= ' WHERE '.implode(' AND ', $condicoes);
	
	//group by - agrupa na ordem (pp1, pp2, pp3, ...)
	$groupby = array();
	for($i = 1; $i <= $k; $i++){
		$groupby[] = ' pp'.$i.'.id_produto_produto';
	}
	$query .= ' GROUP BY '.implode(',', $groupby);
	
	//having count - garante a frequencia minima
	$query .= ' HAVING count(*) > '.$minFrequency.' ';
	//order by - ordena numericamente (pp1, pp2, pp3, ...)
	$query .= ' ORDER BY '.implode(',', $groupby);
	
	echo $query;
	
	return $query;
}
/* QUERY GERADA PARA NIVEL 3 COM A BASE ATUAL:

SELECT  pp1.id_produto_produto AS id_produto_produto1 ,  pp2.id_produto_produto AS id_produto_produto2 ,  pp3.id_produto_produto AS id_produto_produto3 , COUNT(*) as total  

FROM  produto_pedido pp1 ,  produto_pedido pp2 ,  produto_pedido pp3  

WHERE  pp1.id_produto_produto IN (12,14,15,22,23,27,52,62,63,64,71,73,74,80,93,95,102,104,105,13,32,50,53,55,60,61,66,72,78,89,94,96,100,103,19,20,21,44,121,122,24,25,31,38,54,56,65,92,26,34,35,36,37,41,79,81,83,84,85)  

AND  pp1.id_pedido_pedido = pp2.id_pedido_pedido  
AND  pp2.id_produto_produto IN (12,14,15,22,23,27,52,62,63,64,71,73,74,80,93,95,102,104,105,13,32,50,53,55,60,61,66,72,78,89,94,96,100,103,19,20,21,44,121,122,24,25,31,38,54,56,65,92,26,34,35,36,37,41,79,81,83,84,85) 
AND  pp2.id_produto_produto > pp1.id_produto_produto  

AND  pp1.id_pedido_pedido = pp3.id_pedido_pedido  
AND  pp3.id_produto_produto IN (12,14,15,22,23,27,52,62,63,64,71,73,74,80,93,95,102,104,105,13,32,50,53,55,60,61,66,72,78,89,94,96,100,103,19,20,21,44,121,122,24,25,31,38,54,56,65,92,26,34,35,36,37,41,79,81,83,84,85)  
AND  pp3.id_produto_produto > pp2.id_produto_produto  

GROUP BY  pp1.id_produto_produto, pp2.id_produto_produto, pp3.id_produto_produto HAVING count(*) > 22.94  

ORDER BY  pp1.id_produto_produto, pp2.id_produto_produto, pp3.id_produto_produto 
*/	


		
//calcula a regra para todos os casos possiveis e armazena as regras cuja confianca satisfazem a confianca minima. recebe a matriz $L, que contem todos os conjuntos de itens frequentes, e devolve um vetor com todas as regras e suas respectivas confiancas no formato [regra] => confianca
function ruleGen($L){
	global $minConfidence;
	$regras = array();
	for($i = 2; $i <= count($L); $i++){
		foreach($L[$i] as $freqItemset => $frequencia){
			for($j = 1; $j < $i; $j++){
				$combinacoes = combinacao($freqItemset, $i - $j);
					foreach($combinacoes as $subset){
						if(($L[$i][$freqItemset] / $L[$i - $j][$subset]) > $minConfidence){
							$regra = escreveRegra($freqItemset, $subset);
							$regras[$regra] = $L[$i][$freqItemset] / $L[$i - $j][$subset];
						}
					}
			}
		}
	}
	return $regras;
}

//funcao auxiliar que gera o texto da regra, caso ela satisfaca a confianca minima. recebe o conjunto de itens frequentes e um subconjunto dele, e devolve a string que contempla a regra (ex: [12,34=>56])
function escreveRegra($freqItemset, $subset){
	$a = explode(',', $subset);
	$b = explode(',', $freqItemset);
	$c = 0;
	$d = 0;
	while(!empty($a)){		
		if($b[$c] == $a[$d]){
			unset($a[$d]);
			unset($b[$c]);
			$c++; $d++;
		}
		else{
			$c++;
		}
	}
	return $subset.'=>'.implode(',', $b);
}

//gera o nivel 1
function large1Itemsets(){
	global $minFrequency;
	
	$query = 'SELECT pp.id_produto_produto, count(*) as total 
			  FROM produto_pedido pp
			  GROUP BY pp.id_produto_produto
			  HAVING count(*) > '.$minFrequency.'
			  ORDER BY pp.id_produto_produto';
	$resultado = executaQuery($query);
	
	$itemsets = array();
	foreach($resultado as $r){
		$itemsets[$r['id_produto_produto']] = $r['total'];
	}
	
	return $itemsets;
}



//usa a funcao "combinacoesPossiveis" para gerar todas as combinacoes de produtos possiveis de tamanho "tamanhoCombinacao", dada uma transacao "transacao" (note que a quantidade de combinacoes geradas sera Comb(count(transacao),tamanhoCombinacao)). ela devolve o vetor "combinacoesFinal" que contem todas as transacoes
function combinacao($transacao, $tamanhoCombinacao){
	$arrayProdutos = explode(',', $transacao);
	$n = count($arrayProdutos);
	$combinacoesPossiveis = array();
	$combinacoesFinal = array();
 
	//devolve todas as combinacoes em $combinacoesFinal
	combinacoesPossiveis($arrayProdutos, $combinacoesPossiveis, 0, $n, 0, $tamanhoCombinacao, $combinacoesFinal);
	
	for($i = 0; $i < count($combinacoesFinal); $i++){
		$combinacoesFinal[$i] = implode(',', $combinacoesFinal[$i]);
	}
			
	return $combinacoesFinal;
}	


//funcao auxiliar da funcao "combinacao" que gera todos as combinacoes possiveis de tamanho tamanhoCombinacao a partir dos itens em arrayProdutos 
function combinacoesPossiveis($arrayProdutos, &$combinacoesPossiveis, $start, $end, $index, $tamanhoCombinacao, &$combinacoesFinal){
	if ($index == $tamanhoCombinacao){ // combinacao esta pronta
		$combinacoesFinal[] = $combinacoesPossiveis;
		return;
	}
	for ($i = $start; $i < $end && $end - $i + 1 >= $tamanhoCombinacao - $index; $i++){
		$combinacoesPossiveis[$index] = $arrayProdutos[$i];
		combinacoesPossiveis($arrayProdutos, $combinacoesPossiveis, $i + 1, $end, $index + 1, $tamanhoCombinacao, $combinacoesFinal);
	}
}

?>